/**
 * 
 */
package sim.loader;

import sim.loader.SLoaderException;

/**
 * Interface reprsentant un constructeur d'objet (<i>loader</i>) prenant en paramtre un String.
 * Le String peut avoir plusieurs interprtation comme le nom d'un fichier, un mot cl ou une ligne dans un fichier.
 * L'objet qui implmentera cette classe devra spcifier l'interprtation du String afin d'utiliser cette information judicieusement.
 * @author Simon Vzina
 * @since 2015-03-16
 * @version 2015-04-03
 */
public interface SStringLoader {

  /**
   * Mthode qui fait la construction d'un objet dont le type dpendera de la classe implmentant l'interface SStringLoader.
   * L'utilisateur de cette fonction devra connatre le "type" de loader o 
   * @param string - Les informations sous forme String permettant au loader de fonctionner.
   * @return L'objet construit par le loader. Son type devra tre caster par l'utilisateur.
   * @throws SLoaderException S'il y a eu une erreur durant le chargement du fichier.
   */
  public Object load(String string) throws SLoaderException;
  
}//fin Interface SStringLoader
