/**
 * 
 */
package sim.math;

import sim.exception.SNoImplementationException;

/**
 * La classe <b>SAffineTransformation</b> reprsente une classe pouvant raliser des transformations affines sur des vecteurs.
 * 
 * @author Simon Vezina
 * @since 2017-08-21
 * @version 2017-12-20 (version labo  Le ray tracer v2.1)
 */
public class SAffineTransformation {

  /**
   * Mthode qui effectue la transformation d'un <i>origine</i> (vecteur position dsignant l'origine d'une systme d'axe) en 3D
   *  l'aide d'une transformation linaire dfinit  l'aide d'une matrice 4x4. 
   * Un vecteur 4d reprsentant un origine 3d correspond au vecteur (0,0,0,1). 
   * 
   * @param transformation La matrice de transformation.
   * @return Un vecteur origine transform  l'aide d'une matrice de transformation.
   */
  public static SVector3d transformOrigin(SMatrix4x4 transformation)
  {
    throw new SNoImplementationException("Erreur SAffineTransformation : La mthode n'est pas implmente.");
  }
  
  /**
   * Mthode qui effectue la transformation d'un <i>vecteur position</i> en 3D (converti en vecteur 4d o la 4ime composante est 1),
   *  l'aide d'une transformation linaire dfinit  l'aide d'une matrice 4x4.  
   * 
   * @param transformation La matrice de transformation.
   * @param v Le vecteur position  transformer.
   * @return Un vecteur position transform  l'aide d'une matrice de transformation.
   */
  public static SVector3d transformPosition(SMatrix4x4 transformation, SVector3d v)
  {
    throw new SNoImplementationException("Erreur SAffineTransformation : La mthode n'est pas implmente.");
  }
  
  
  /**
   * Mthode qui effectue la transformation d'un <i>vecteur orientation</i> en 3D (converti en vecteur 4d o la 4ime composante est 1),
   *  l'aide d'une transformation linaire dfinit  l'aide d'une matrice 4x4.  
   * 
   * @param transformation La matrice de transformation.
   * @param v Le vecteur orientation  transformer.
   * @return Un vecteur orientation transform  l'aide d'une matrice de transformation.
   */
  public static SVector3d transformOrientation(SMatrix4x4 transformation, SVector3d v)
  {
    throw new SNoImplementationException("Erreur SAffineTransformation : La mthode n'est pas implmente.");
  }
  
  /**
   * Mthode qui effectue la transformation d'un <i>vecteur orientation</i> en 3D (converti en vecteur 4d o la 4ime composante est 1),
   *  l'aide d'une transformation linaire dfinit  l'aide d'une matrice 4x4. 
   * Puisque cette transformation ncessite la transformation d'un origine de rfrence au vecteur orientation,
   * cette version d'implmentation utilise une origine transforme calcule  l'extrieur de l'appel de cette mthode. 
   * Un usage rptitif de cette transformation avec le mme origine transforme
   * permettra d'optenir un conomie d'allocation de mmoire et une rduction de calcul rptitif.
   * 
   * @param transformation La matrice de transformation.
   * @param transformed_origin L'origine transforme du vecteur orientation.
   * @param v Le vecteur orientation  transformer.
   * @return Un vecteur orientation transform  l'aide d'une matrice de transformation.
   */
  public static SVector3d transformOrientation(SMatrix4x4 transformation, SVector3d transformed_origin, SVector3d v)
  {
    throw new SNoImplementationException("Erreur SAffineTransformation : La mthode n'est pas implmente.");
  }
  
  /**
   * Mthode qui effectue la transformation d'un <i>vecteur normale</i>  l'aide d'une transformation linaire.  
   *  
   * @param transformation La matrice de transformation.
   * @param v Le vecteur normale  transformer.
   * @return Un vecteur normale transform  l'aide d'une matrice de transformation.
   */
  public static SVector3d transformNormal(SMatrix4x4 transformation, SVector3d v)
  {
	throw new SNoImplementationException("Erreur SAffineTransformation : La mthode n'est pas implmente.");
   
  }
  
  /**
   * Mthode qui effectue la transformation d'un <i>vecteur normale</i>  l'aide d'une transformation linaire. 
   * Puisque cette transformation ncessite la transformation d'un origine de rfrence au vecteur orientation,
   * cette version d'implmentation utilise une origine transforme calcule  l'extrieur de l'appel de cette mthode. 
   * Un usage rptitif de cette transformation avec le mme origine transforme
   * permettra d'optenir un conomie d'allocation de mmoire et une rduction de calcul rptitif.
   * 
   * @param transformation La matrice de transformation.
   * @param transformed_origin L'origine transforme du vecteur orientation.
   * @param v Le vecteur normale  transformer.
   * @return Un vecteur normale transform  l'aide d'une matrice de transformation.
   */
  public static SVector3d transformNormal(SMatrix4x4 transformation, SVector3d transformed_origin, SVector3d v) 
  {
    throw new SNoImplementationException("Erreur SAffineTransformation : La mthode n'est pas implmente.");
  }
  
}// fin de la classe SLinearTransformation
